﻿Type=Service
Version=6.31
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Private mTimeSync As Timer
	Public m_DB 	As SQL 
	Private mTableLog As String	= "Log"
End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.

'	mTimeSync.Initialize("TimerSync", 1 * DateTime.TicksPerMinute)
'	mTimeSync.Enabled = True

End Sub

Sub Service_Start (StartingIntent As Intent)
	
	Log("Start Service " & GetDateTime)
	
	StartServiceAt(Sync, DateTime.Now, False)

	
	m_DB.Initialize(File.DirInternal, "Log.db", True)
	CreateTable

End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
	
		' faccio ripartire il servizio dopo averlo "ucciso"
	StartServiceAt(Me, DateTime.Now + 1 * DateTime.TicksPerMinute, True)
	
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub

Private Sub GetDateTime As String
	
	Dim aStrDateTime As String	=	DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now)
	
	Return aStrDateTime
End Sub



private Sub TimerSync_Tick
	
	Return

	Log("TimerTick " & GetDateTime)
	
	WriteLog("CheckConnection  " & CheckConnection)
	WriteLog("TimerTick at " & GetDateTime) 
	
	CallSub(Main, "LoadData")
	
End Sub

private Sub CreateTable
	
	Dim aRet As Boolean = True
	Dim aRec As Cursor
	
	' esempio sql
	'sQuery = "If Not exists (Select * from dbo.sysobjects where id = object_id(N'[dbo].[MA_NonFiscalNumbers]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)"
	
	aRec = m_DB.ExecQuery("SELECT name FROM sqlite_master Where Type='table' AND name = '" & mTableLog & "'")

	If aRec.RowCount = 0 Then
			' campi log app
		Dim aFields As Map
		aFields.Initialize
		
		aFields.Put("DateTime", 				DBUtils.DB_DATE)
		aFields.Put("LogField", 				"TEXT")
		
		' tabella log app
		DBUtils.CreateTable(m_DB, mTableLog, aFields, "Table")
	Else
	'	DBUtils.DropTable(m_DB, mTableLog)
	'	Log("cancello tabella")
	End If

	aRec.Close

End Sub


Private Sub WriteLog(aLog As String)
	
	
	Dim afields As Map
	afields.Initialize
	
	afields.Put("DateTime", 			DateTime.Now)
	afields.Put("LogField", 			aLog)
	
	
	Dim aRecords As List
	aRecords.Initialize
	
	aRecords.Add(afields)
	
	DBUtils.InsertMaps(m_DB, mTableLog, aRecords)	
End Sub


' controlla se c'è la connessione SIM e WIFI
Sub CheckConnection As Boolean
	
	Dim ok As Boolean = True
	Dim device As Phone
	
	Dim server As ServerSocket
	server.Initialize(0, "")
	
	If server.GetMyWifiIP = "127.0.0.1" And device.GetDataState <> "CONNECTED" Then 
		ok = False
		' non mettere perchè se viene usata dal servizio si blocca.
	'	Msgbox("Manca la connessione","Syncronizzazione non possibile")
	End If
	
	Return ok
	
End Sub 