﻿Type=Service
Version=6.31
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Private mTimeSync As Timer

End Sub

Sub Service_Create

	Log("Create Sync....")
	mTimeSync.Initialize("TimerSync", 1 * DateTime.TicksPerMinute)
	mTimeSync.Enabled = True

End Sub

Sub Service_Start (StartingIntent As Intent)
	Log("Start Sync Service")
	
	Log(StartingIntent.ACTION_PICK)
	Log(StartingIntent.ExtrasToString)
		
	StartServiceAt(Me, DateTime.Now + 1 * DateTime.TicksPerMinute, True)
	
End Sub

Sub Service_Destroy

End Sub

private Sub TimerSync_Tick
	
	Log("TimerSyncTick " & GetDateTime)
	

	
	WriteLog("Is Connected  " & CheckConnection)
	WriteLog("TimerTick at " & GetDateTime) 
	
	CallSub(Main, "LoadData")
	
End Sub



Private Sub WriteLog(aLog As String)
	
	
	Dim afields As Map
	afields.Initialize
	
	afields.Put("DateTime", 			DateTime.Now)
	afields.Put("LogField", 			aLog)
	
	Dim aRecords As List
	aRecords.Initialize
	
	aRecords.Add(afields)
	
	DBUtils.InsertMaps(Starter.m_DB, "Log", aRecords)	
End Sub


' controlla se c'è la connessione SIM e WIFI
Sub CheckConnection As Boolean
	
	Dim ok As Boolean = True
	Dim device As Phone
	
	Dim server As ServerSocket
	server.Initialize(0, "")
	
	If server.GetMyWifiIP = "127.0.0.1" And device.GetDataState <> "CONNECTED" Then 
		ok = False
		' non mettere perchè se viene usata dal servizio si blocca.
	'	Msgbox("Manca la connessione","Syncronizzazione non possibile")
	End If
	
	Return ok
	
End Sub 

Private Sub GetDateTime As String
	
	Dim aStrDateTime As String	=	DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now)
	
	Return aStrDateTime
End Sub
